org.apache.hc.core5.http.io.entity

## Class ByteArrayEntity

- java.lang.Object
- - org.apache.hc.core5.http.io.entity.AbstractHttpEntity
  - - org.apache.hc.core5.http.io.entity.ByteArrayEntity

- All Implemented Interfaces:
    Closeable, AutoCloseable, EntityDetails, HttpEntity

      @Contract(threading=IMMUTABLE_CONDITIONAL)
      public class ByteArrayEntity
      extends AbstractHttpEntity

  A self contained, repeatable entity that obtains its content from a byte array.

  This class contains `immutable attributes` but subclasses may contain additional immutable or mutable attributes.

  Since:
    4.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ByteArrayEntity(byte[] buf, ContentType contentType)` Constructs a new instance with the given attributes kept as immutable.
    `ByteArrayEntity(byte[] buf, ContentType contentType, boolean chunked)` Constructs a new instance with the given attributes kept as immutable.
    `ByteArrayEntity(byte[] buf, ContentType contentType, String contentEncoding)` Constructs a new instance with the given attributes kept as immutable.
    `ByteArrayEntity(byte[] buf, ContentType contentType, String contentEncoding, boolean chunked)` Constructs a new instance with the given attributes kept as immutable.
    `ByteArrayEntity(byte[] buf, int off, int len, ContentType contentType)` Constructs a new instance with the given attributes kept as immutable.
    `ByteArrayEntity(byte[] buf, int off, int len, ContentType contentType, boolean chunked)` Constructs a new instance with the given attributes kept as immutable.
    `ByteArrayEntity(byte[] buf, int off, int len, ContentType contentType, String contentEncoding)` Constructs a new instance with the given attributes kept as immutable.
    `ByteArrayEntity(byte[] buf, int off, int len, ContentType contentType, String contentEncoding, boolean chunked)` Constructs a new instance with the given attributes kept as immutable.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()`
    `InputStream` | `getContent()` Gets a content stream of the entity.
    `long` | `getContentLength()` Gets length of this entity, if known.
    `boolean` | `isRepeatable()` Tests if the entity is capable of producing its data more than once.
    `boolean` | `isStreaming()` Tests whether this entity depends on an underlying stream.
    `void` | `writeTo(OutputStream outStream)` Writes this entity to an OutputStream.

    - ### Methods inherited from class org.apache.hc.core5.http.io.entity.AbstractHttpEntity

      `getContentEncoding, getContentType, getTrailerNames, getTrailers, isChunked, toString, writeTo`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ByteArrayEntity

          public ByteArrayEntity(byte[] buf,
                                 int off,
                                 int len,
                                 ContentType contentType,
                                 String contentEncoding,
                                 boolean chunked)

      Constructs a new instance with the given attributes kept as immutable.
      Parameters:
        `buf` - The message body contents as a byte array buffer.
        `off` - The offset in the buffer of the first byte to read.
        `len` - The maximum number of bytes to read from the buffer.
        `contentType` - The content-type, may be null.
        `contentEncoding` - The content encoding string, may be null.
        `chunked` - Whether this entity should be chunked.
      Since:
        5.0

    - #### ByteArrayEntity

          public ByteArrayEntity(byte[] buf,
                                 int off,
                                 int len,
                                 ContentType contentType,
                                 String contentEncoding)

      Constructs a new instance with the given attributes kept as immutable.

      The new instance:

      - is not chunked.
      Parameters:
        `buf` - The message body contents as a byte array buffer.
        `off` - The offset in the buffer of the first byte to read.
        `len` - The maximum number of bytes to read from the buffer.
        `contentType` - The content-type, may be null.
        `contentEncoding` - The content encoding string, may be null.
      Since:
        5.0

    - #### ByteArrayEntity

          public ByteArrayEntity(byte[] buf,
                                 ContentType contentType,
                                 String contentEncoding,
                                 boolean chunked)

      Constructs a new instance with the given attributes kept as immutable.

      The new instance:

      - starts reading it's contents at index 0 in the buffer.
      - has the content length of the given buffer.
      Parameters:
        `buf` - The message body contents as a byte array buffer.
        `contentType` - The content-type, may be null.
        `contentEncoding` - The content encoding string, may be null.
        `chunked` - Whether this entity should be chunked.
      Since:
        5.0

    - #### ByteArrayEntity

          public ByteArrayEntity(byte[] buf,
                                 ContentType contentType,
                                 String contentEncoding)

      Constructs a new instance with the given attributes kept as immutable.

      The new instance:

      - is not chunked.
      - starts reading it's contents at index 0 in the buffer.
      - has the content length of the given buffer.
      Parameters:
        `buf` - The message body contents as a byte array buffer.
        `contentType` - The content-type, may be null.
        `contentEncoding` - The content encoding string, may be null.
      Since:
        5.0

    - #### ByteArrayEntity

          public ByteArrayEntity(byte[] buf,
                                 ContentType contentType,
                                 boolean chunked)

      Constructs a new instance with the given attributes kept as immutable.

      The new instance:

      - starts reading it's contents at index 0 in the buffer.
      - has the content length of the given buffer.
      - does not define a content encoding.
      Parameters:
        `buf` - The message body contents as a byte array buffer.
        `contentType` - The content-type, may be null.
        `chunked` - Whether this entity should be chunked.

    - #### ByteArrayEntity

          public ByteArrayEntity(byte[] buf,
                                 ContentType contentType)

      Constructs a new instance with the given attributes kept as immutable.

      The new instance:

      - is not chunked.
      - starts reading it's contents at index 0 in the buffer.
      - has the content length of the given buffer.
      - does not define a content encoding.
      Parameters:
        `buf` - The message body contents as a byte array buffer.
        `contentType` - The content-type, may be null.

    - #### ByteArrayEntity

          public ByteArrayEntity(byte[] buf,
                                 int off,
                                 int len,
                                 ContentType contentType,
                                 boolean chunked)

      Constructs a new instance with the given attributes kept as immutable.

      The new instance:

      - does not define a content encoding.
      Parameters:
        `buf` - The message body contents as a byte array buffer.
        `off` - The offset in the buffer of the first byte to read.
        `len` - The maximum number of bytes to read from the buffer.
        `contentType` - The content-type, may be null.
        `chunked` - Whether this entity should be chunked.

    - #### ByteArrayEntity

          public ByteArrayEntity(byte[] buf,
                                 int off,
                                 int len,
                                 ContentType contentType)

      Constructs a new instance with the given attributes kept as immutable.

      The new instance:

      - is not chunked.
      - does not define a content encoding.
      Parameters:
        `buf` - The message body contents as a byte array buffer.
        `off` - The offset in the buffer of the first byte to read.
        `len` - The maximum number of bytes to read from the buffer.
        `contentType` - The content-type, may be null.
      Since:
        5.0

  - ### Method Detail

    - #### isRepeatable

          public final boolean isRepeatable()

      Tests if the entity is capable of producing its data more than once. A repeatable entity's getContent() and writeTo(OutputStream) methods can be called more than once whereas a non-repeatable entity's can not.

      This implementation always returns `false`.

      This implementation always returns `true`.

      Specified by:
        `isRepeatable` in interface `HttpEntity`
      Overrides:
        `isRepeatable` in class `AbstractHttpEntity`
      Returns:
        true if the entity is repeatable, false otherwise.

    - #### getContentLength

          public final long getContentLength()

      Description copied from interface: `EntityDetails`
      Gets length of this entity, if known.
      Returns:
        the length of this entity, may be `0`.

    - #### getContent

          public final InputStream getContent()

      Description copied from interface: `HttpEntity`
      Gets a content stream of the entity. `Repeatable` entities are expected to create a new instance of `InputStream` for each invocation of this method and therefore can be consumed multiple times. Entities that are not `repeatable` are expected to return the same `InputStream` instance and therefore may not be consumed more than once.

      If this entity belongs to an incoming HTTP message, calling `InputStream.close()` on the returned `InputStream` will try to consume the complete entity content to keep the connection alive. In cases where this is undesired, e.g. when only a small part of the content is relevant and consuming the complete entity content would be too inefficient, only the HTTP message from which this entity was obtained should be closed (if supported).

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated after the `InputStream.close()` method is invoked.

      Returns:
        content stream of the entity.
      See Also:
        `HttpEntity.isRepeatable()`

    - #### writeTo

          public final void writeTo(OutputStream outStream)
                             throws IOException

      Description copied from class: `AbstractHttpEntity`
      Writes this entity to an OutputStream.
      Specified by:
        `writeTo` in interface `HttpEntity`
      Overrides:
        `writeTo` in class `AbstractHttpEntity`
      Parameters:
        `outStream` - Where to write the entity, never null.
      Throws:
        `IOException` - if the entity cannot generate its content stream; also thrown if the output stream is closed.

    - #### isStreaming

          public final boolean isStreaming()

      Tests whether this entity depends on an underlying stream. Streamed entities that read data directly from the socket should return `true`. Self-contained entities should return `false`. Wrapping entities should delegate this call to the wrapped entity.

      This implementation always returns `false`.

      Returns:
        `true` if the entity content is streamed, `false` otherwise

    - #### close

          public final void close()
                           throws IOException

      This implementation is a no-op.

      Throws:
        `IOException`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.